#include "polinom.h"
#include <stdio.h>

void unos(int a[], int n){
	//n je poznato, mi samo elemente treba da upisemo u niz a
	printf("Unesite elemente:\n");
	int i;
	for(i = 0; i < n; i++)
		scanf("%d", &a[i]);
}

void ispis(int a[], int n){
	printf("Elementi niza su:\n");
	int i;
	for(i = 0; i < n; i++)
		printf("%d ", a[i]);
	printf("\n");
}

int suma(int a[], int n){
	//cesto se pravi greska, samo int suma; bez = 0
	//ponekad radi na ispitu, a ne radi kada se automatski pregleda
	int suma = 0;
	int i;
	for(i = 0; i < n; i++)
		suma += a[i];
	return suma;
}

int skalarni(int a[], int b[], int n){
	//a1 * b1 + a2 * b2 + ... + an * bn
	int rez = 0;
	int i;
	for(i = 0; i < n; i++)
		rez += a[i] * b[i];
	return rez;
}

void ispis_polinoma(int a[], int n){
	//a predstavlja niz koeficijenata
	//n predstavlja stepen polinoma
	
	//dakle ako a ima m elenata, n = m - 1
	
	//a0 + a1 * x + a2 * x^2 + a3 * x^3 + ... + an * x^n
	//0: a0
	//1: a1 * x
	//svaki sledeci: ai * x^i
	
	int i;
	int prvi_put_ispis = 1;
	for(i = 0; i < n + 1; i++){
		if(a[i] == 0)
			continue;
		
		if(prvi_put_ispis){
			prvi_put_ispis = 0;
		}
		else{
			printf(" + ");
		}
	
		if(i == 0)
			printf("%d", a[i]);
		else if(i == 1)
			printf("%d * x", a[i]);
		else
			printf("%d * x^%d", a[i], i);
	}
}

int suma_polinoma(int a[], int n, int b[], int m, int c[]){
	//1+2x+3x^2 + 1+2x+3x^2
	//=2+4x+6x^2
	
	int stepen_novog = n > m ? n : m;
	int i;
	for(i = 0; i < stepen_novog; i++){
		c[i] = 0;
		//da li si dosao do kraja prvog
		if(i < n)
			c[i] += a[i];
		//da li si dosao do kraja drugog
		if(i < m)
			c[i] += b[i];
	}
	return stepen_novog;
}

void mnoz_skalarom(int a[], int n, int c){
	int i;
	for(i = 0; i <= n; i++)
		a[i] = a[i] * c;
}

int vr_poly(int a[], int n, int x){
	int vrednost = 0;
	int i;
	for(i = n; i >= 0; i--){
		vrednost = vrednost * x + a[i];
	}
	return vrednost;
}